﻿degToRad = Math.PI/180;
sqrt2 = Math.sqrt(2);
++initCtr;
if (initCtr > 1)
	trace("Script called twice");

MovieClip.prototype.drawBGCircle = function()
{
	var sRad = 150;
	var alphas = [100,0];
	var ratios = [0xAA,0xFF];
  	var colors = [0,0];
	var matrix = { matrixType:"box", x:-sRad, y:-sRad, w:sRad*2, h:sRad*2, r: 0 }

	this.moveTo(-sRad,-sRad);
  	this.beginGradientFill("radial",colors,alphas,ratios,matrix);
	this.lineTo(sRad,-sRad);
	this.lineTo(sRad,sRad);
	this.lineTo(-sRad,sRad);
	this.lineTo(-sRad,-sRad);
	this.endFill();
}

function drawArc(mc, x,y,radius,bA,eA)
{
	var a = Math.tan(Math.PI/8);	// 22.5 for circle
	var r = radius;
	var theta = 45*degToRad;
	var cr = radius/Math.cos(theta/2);
	var angle = (ba+45)*degToRad;
	var cangle = angle-theta/2;
	var n = (ea-ba)/45;

	for (var i=0;i < n;i++,angle += theta,cangle += theta) 
	{
		var endX = r*Math.cos (angle);
		var endY = r*Math.sin (angle);
		var cX = cr*Math.cos (cangle);
		var cY = cr*Math.sin (cangle);
		mc.curveTo(cX+x,cY+y, endX+x,endY+y);
	}
}

function drawNegArc(mc, x,y,radius,bA,eA)
{
	var a = Math.tan(Math.PI/8);	// 22.5 for circle
	var r = radius;
	var theta = 45*degToRad;
	var cr = radius/Math.cos(theta/2);
	var angle = (ba+45)*degToRad;
	var cangle = angle-theta/2;
	var n = (ea-ba)/45;

	for (var i=0;i < n;i++,angle += theta,cangle += theta) 
	{
		var endX = r*Math.cos (angle);
		var endY = r*Math.sin (angle);
		var cX = cr*Math.cos (cangle);
		var cY = cr*Math.sin (cangle);
		mc.curveTo(x+cX,y-cY, x+endX,y-endY);
	}
}

var g_alphas = [10,100,10];
var g_ratios = [0x0,0x7F,0xFF];
var radians = 0;
// build our matrix using the "box" method
var g_matrix = { matrixType:"box", x:0, y:0, w:100, h:100, r: radians }

function drawYin(mc, x, y, radius, fC, fA, withHole)
{

	var rad2 = radius/2;

	mc.moveTo(x+radius,y);  // same as x+cos(0)*r, y+sin(0)*r

  var colors = [fC,fC,0xFFFFFF-fC];
  mc.beginGradientFill("radial",colors,g_alphas,g_ratios,g_matrix);

	// mc.beginFill(fC,fA);


	drawArc(mc, x, y, radius, 0, 180);
	drawArc(mc, x-rad2,y, rad2, 180, 360);
	drawNegArc(mc, x+rad2,y, rad2, 180, 360);
	
	if (withHole) {
		var radC = rad2*(_root.sqrt2-1);
		mc.moveTo(x+radC-rad2,y);
		drawArc(mc, x-rad2, y, radC, 0, 360);
	}

	mc.endFill()
}

function drawYang(mc, x, y, radius, fC, fA, withHole)
{
	var rad2 = radius/2;

	mc.moveTo(x-radius,y);  // same as x+cos(0)*r, y+sin(0)*r


  var colors = [fC,fC,0xFFFFFF-fC];
  mc.beginGradientFill("linear",colors,g_alphas,g_ratios,g_matrix);
	// mc.beginFill(fC,fA);


	drawArc(mc, x, y, radius, 180, 360);
	drawArc(mc, x+rad2,y, rad2, 0, 180);
	drawNegArc(mc, x-rad2,y, rad2, 0, 180);

	if (withHole) {
		var radC = rad2*(_root.sqrt2-1);
		mc.moveTo(x+rad2+radC,y);
		drawArc(mc, x+rad2, y, radC, 0, 360);
	}

	mc.endFill()
}


function drawCircle(mc, x,y,radius, fC,fA)
{
	mc.moveTo(x+radius,y);  // same as x+cos(0)*r, y+sin(0)*r
	mc.beginFill(fC,fA);
	drawArc(mc, x, y, radius, 0, 360);
	mc.endFill()
}

function drawSprite()
{
	var spr = _root.sprites[this.sIdx];
	// trace("ds");
	this.clear();
	var x = spr.sx;
	var y = spr.sy;
	var rad = spr.rad;
	var rad2 = rad/2;
	var radC = rad2*(_root.sqrt2-1);
	drawYin(this, x, y, rad, spr.tint, spr.sa, true);
//	drawCircle(this,x-rad2,y,radC,spr.tintB,spr.sa);
//	drawYang(this, x, y, rad, spr.tintB, spr.sa);
//	drawCircle(this,x+rad2,y,radC,spr.tint,spr.sa);
	// this.onEnterFrame = undefined;
}

function randomizeSprite(i)
{
	_root.sprites[i].tint = Math.floor(Math.random()*0xFFFFFF);
	_root.sprites[i].tintb = Math.floor(Math.random()*0xFFFFFF);
	_root.sprites[i].rad = _root.minSpriteRad + Math.random()*(_root.maxSpriteRad - _root.minSpriteRad);
	_root.sprites[i].spin = Math.random()*8*Math.PI;
	_root.sprites[i].shape = Math.floor(Math.random()*5);
}

function updateSprites()
{
	this._rotation = this._rotation + 1;
	for (var i = 0; i < _root.nbrSprites; ++i)
	{
		// var spr = _root.sprites[i];
		_root.sprites[i].ctr++;
		if (_root.sprites[i].ctr > _root.spritePeriod)
		{
			_root.sprites[i].ctr = 0;
			randomizeSprite(i);
		}
		var r = _root.sprites[i].ctr / _root.spritePeriod;
		_root.sprites[i].r = r;
		_root.sprites[i].sx = -Math.cos(r*Math.PI*2)*_root.maxXTravel;
		_root.sprites[i].sy = Math.sin(r*Math.PI*2)*_root.maxYTravel;
		_root.sprites[i].sa = Math.sin(r*Math.PI) * 100;
		_root.sprites[i].cx = Math.cos(r*_root.sprites[i].spin);
		_root.sprites[i].cy = -Math.sin(r*_root.sprites[i].spin);
	}
}

function clickMe()
{
	getURL(_root.destURL);
}

function init()
{
	if (_root.inited != undefined)
		return;
	// trace("Initing");
	var howManyReflections = 5;

	nbrSprites = 3;
	spritePeriod = 200;
	minSpriteRad = Stage.width/16;
	maxSpriteRad = Stage.width/4;
	maxYTravel = Stage.width/6;
	maxXTravel = Stage.width/3;
	sprites = new Array(_root.nbrSprites);

	attachMovie("ObjectCell", "bm_mc", 1);

	var	n = 0;

	for (var j = 0; j < _root.nbrSprites; ++j) 
	{
		for (var i = 0; i < howManyReflections; ++i) 
		{
			var	nam = "obj_" + i + "_" + j;
			bm_mc.attachMovie("ObjectCell", nam, n);
			// _root.bm_mc[nam]._x = Stage.width/2;
			// _root.bm_mc[nam]._y = Stage.height/2;
			bm_mc[nam]._rotation = i*360/howManyReflections;
			bm_mc[nam].onEnterFrame = drawSprite;
			bm_mc[nam].sIdx = j;
			n++;

			nam = "objR_" + i + "_" + j;
			bm_mc.attachMovie("ObjectCell", nam, n);
			// _root.bm_mc[nam]._x = Stage.width/2;
			// _root.bm_mc[nam]._y = Stage.height/2;
			bm_mc[nam]._xscale = -100;
			bm_mc[nam]._rotation = i*360/howManyReflections;
			bm_mc[nam].onEnterFrame = drawSprite;
			bm_mc[nam].sIdx = j;
			n++;

		}
	}
	
	for (var i = 0; i < _root.nbrSprites; ++i) 
	{
		sprites[i] = new Array();
		sprites[i].ctr = (i * _root.spritePeriod) / _root.nbrSprites;
		randomizeSprite(i);
	}
	bm_mc.onEnterFrame = updateSprites;
	bm_mc.onMouseUp = clickMe;
	bm_mc._x = Stage.width/2;
	bm_mc._y = Stage.height/2;

	attachMovie("circle", "circ_mc", 2);
	circ_mc._x = 0;
	circ_mc._y = 0;
	bm_mc.setMask(circ_mc);

	this.createEmptyMovieClip("bg_mc", 0);
	// var newColor = new Color(bg_mc);
	// newColor.setRGB(0);
	bg_mc._x = 150;
	bg_mc._y = 150;
	bg_mc.drawBGCircle();

	
	_root.destURL = "http://www.krazydad.com/metascope.html";
	inited = true;
}

init();
